varying	vec3 lt;
varying	vec3 ht;
varying	vec3 p;

uniform sampler3D noiseMap;
uniform sampler2D cellMap;
uniform	float	  time;

const float freq  = 2.071935;
const float freq2 = freq * freq;
const vec3  one   = vec3 ( 1.0 );

float f ( const in vec2 tex )
{
    float    t = texture2D ( cellMap, tex ).x;

    return t*t;
}

vec3    df ( const in vec2 p )
{
    const float dx = 0.01;

    float    fx = f ( p + vec2 ( dx, 0 ) ) - f ( p - vec2 ( dx, 0 ) ) / (2.0*dx);
    float    fy = f ( p + vec2 ( 0, dx ) ) - f ( p - vec2 ( 0, dx ) ) / (2.0*dx);

    return vec3 ( fx, fy, 0 );
}

void main(void)
{
    vec3     ns1     = texture3D ( noiseMap, p + 4.0*time * vec3 ( 0.1, 0.0831, 0.119 ) ).xyz;
    vec2     tex     = vec2 ( 1.0, 2.0 )*gl_TexCoord [0].xy + 0.02*ns1.xy;
    float    d1      = abs ( f ( tex + vec2 ( 0.01, 0 ) ) - f ( tex ) );
    float    d2      = abs ( f ( tex + vec2 ( 0, 0.01 ) ) - f ( tex ) );
    vec3	 n       = vec3 ( 0.0, 0.0, 1.0 );
    vec3     nn      = normalize ( n - 7.0*vec3 ( d1, d2, 0 ) );
    vec3     ln      = normalize ( lt );
    vec3     hn      = normalize ( ht );
    float    diffuse = 0.4 + max ( 0.0, dot ( nn, ln ) );
    float    spec    = 0.5*pow ( max ( 0.0, dot ( nn, hn ) ), 30.0 );

   gl_FragColor = vec4 ( f(tex)+f(2.0*tex), 0.0, 0.0, 1.0 )*diffuse + spec*vec4 ( 1.0, 1.0, 0.0, 1.0 );
}