varying	vec3 lt;
varying	vec3 ht;
varying	vec3 p;

uniform sampler2D cellMap;

void main(void)
{
	vec2	tex = 0.5*vec2 ( 1.0, 2.0 ) * gl_TexCoord [0].xy;
	vec4	f   = texture2D ( cellMap, tex );
	float	scale = 30.0;
	float	bias  = 0.04;
	
	float	v = scale*(f.y - f.x - bias);
	
    vec3	 n       = vec3 ( 0.0, 0.0, 1.0 );
    vec3     nn      = n;
    vec3     ln      = normalize ( lt );
    vec3     hn      = normalize ( ht );
    float    diffuse = 0.4 + max ( 0.0, dot ( nn, ln ) );
    float    spec    = 0.5*pow ( max ( 0.0, dot ( nn, hn ) ), 30.0 );

	gl_FragColor = vec4 ( vec3 ( clamp ( v, 0.0, 1.0 ) )*diffuse, 1.0 );	
}
