//
// Fragment shader for realtime cellular texture (F0)
//
// gl_TexCoord [0].xy - point being processed
// pt                 - current fragment coords
//

#define	EPS	0.0001

uniform	sampler2D prevMap;
varying	vec2	  pt;

void main (void)
{
	vec2	delta = abs ( pt - gl_TexCoord [0].xy );
	
	if ( delta.x > 0.5 )
		delta.x = 1.0 - delta.x;
		
	if ( delta.y > 0.5 )
		delta.y = 1.0 - delta.y;
		
	float	dist  = min ( length ( delta ), 1.0 );
	float	dist1 = texture2D ( prevMap, gl_FragCoord.xy / 512.0 ).r/2.0;	// fetch 1-st closest distance

	if ( dist <= dist1 + EPS )										// if we're closer => discard
		discard;
		
	gl_FragColor = vec4 ( 0.0 , 2.0*dist, 0.0, 1.0 );
	gl_FragDepth = dist;
}
